#include "StdAfx.h"
#include "ListBoxScriptletPlugin.h"
#include "XMLUtil.h"
#include "ListBox.h"
#include "ScriptletConstant.h"
#include "ScriptletContainerFactory.h"

REGISTER_SCRIPTLETCOMPONENTPLUGIN_CREATOR(SCRIPTLET_LISTBOX_NODE, CListBoxScriptletPlugin);
CListBoxScriptletPlugin::CListBoxScriptletPlugin(void)
{
}

CListBoxScriptletPlugin::~CListBoxScriptletPlugin(void)
{
}

BOOL CListBoxScriptletPlugin::ModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode)
{
	BOOL bSuccess = __super::ModifyComponent(pParent, pTarget, pNode);
	if (bSuccess)
	{
		CListBox* pListBox = reinterpret_cast<CListBox*>(pTarget);
		if (pListBox == NULL)
		{
			return FALSE;
		}
		TCHAR szValue[SCRIPTLET_MAX_VALUE] = {0};
		long lValue = 0;

		//itemtemplate
		TiXmlElement* pItemTemplateNode = pNode->FirstChildElement(CT2CA(SCRIPTLET_ITEMTEMPLATE_NODE));
		if (pItemTemplateNode)
		{
			TiXmlElement* pItemTemplateRootNode = pItemTemplateNode->FirstChildElement();
			if (NULL != pItemTemplateRootNode)
			{
				pListBox->SetItemTemplate(pItemTemplateRootNode);
			}
		}
		//onselect
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_ONSELECT_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_ONSELECT_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			IItemListener* itemlistener = CScriptletContainerFactory::get_instance()->CreateitemListener(szValue);
			if ( NULL != itemlistener )
			{
				pListBox->AddItemListener(itemlistener);
				itemlistener->AutoRelease();
			}
		}
	}
	return bSuccess;
}
BOOL CListBoxScriptletPlugin::PreModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode)
{
	BOOL bSuccess = __super::PostModifyComponent(pParent, pTarget, pNode);
	if (bSuccess)
	{
		CListBox* pListBox = reinterpret_cast<CListBox*>(pTarget);
		if (pListBox == NULL)
		{
			return FALSE;
		}
		TCHAR szValue[SCRIPTLET_MAX_VALUE] = {0};


		//default_select
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_DEFAULT_SELECT_NODE), szValue, _countof(szValue)) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_DEFAULT_SELECT_NODE), szValue, _countof(szValue)))
		{
			if( CString(szValue).Find(L"{Binding ") != 0 )
			{
				long lValue = _ttol(szValue);
				pListBox->Select(lValue);
			}
		}
	}
	return bSuccess;
}
CComponent* CListBoxScriptletPlugin::_CreateComponent(TiXmlElement* pNode)
{
	CComponent* pComponent = new CListBox;
	return pComponent;
}